 Introduction to Awali
============================

Awali is a C++ generic library for weighted finite state machines.


Using Awali
-----------

Awali can be used for the while at four different levels:

- through the *Cora* binary: Cora is a programm that offers many commands to
  compute on automata and transducers.

- as a python module; the ``python`` directory contains the files to produce
  a module ``awalipy`` which can be imported into python, ipython or ipython notebook.

- as a simple C++ library; the ``awali/dyn`` directory contains headers that
  allow to use Awali without worrying about types. This library uses
  the algorithms of the template library which are compiled on-the-fly
  for the requested type.

- as a template library; the ``awali/sttc`` directory contains all the
  Awali template library, sometimes called the *static layer*.




History
-------

Awali results from a fork of Vaucanson 2.

Compilation and installation
----------------------------

Compilation and installation are described in the [INSTALL files](`INSTALL.md`).

Documentation
-------------

The documentation is under construction and unfortunately not yet available. 

Licence
-------

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at
your option) any later version.

The complete GNU General Public Licence Notice can be found as the
``COPYING.txt`` file in the root directory.


Contacts
--------

*  Jacques Sakarovitch  
   IRIF / CNRS, University Paris Diderot and Telecom Paristech  
   Jacques.Sakarovitch@telecom-paristech.fr  
   www.telecom-paristech.fr/~jsaka  

* Sylvain Lombardy  
  LaBRI / Bordeaux INP  
  Sylvain.Lombardy@labri.fr  
  wwww.labri.fr/~slombard
  
* Victor Marsault  
  UPEM / CNRS  
  Victor.Marsault@u-pem.fr  
  http://victor.marsault.xyz  
