// This file is part of Awali.
// Copyright 2016-2019 Sylvain Lombardy, Victor Marsault, Jacques Sakarovitch
//
// Awali is a free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#include <awali/dyn/bridge-sttc/explicit-automaton.cc>
#include <awali/sttc/history/history.hh>
#include<vector>
#include<stdexcept>

#include<set-types.hh>

namespace awali {

  extern "C" history_kind_t get_history_kind(dyn::automaton_t aut) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return a->history()->get_nature();
  }

  extern "C" unsigned get_origin_state(dyn::automaton_t aut, unsigned s) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return a->history()->get_state(s);
  }

  extern "C" std::vector<unsigned> get_origin_states(dyn::automaton_t aut, unsigned s) {
    auto a=dyn::get_stc_automaton<context_t>(aut);
    return a->history()->get_state_set(s);
  }

}
