// This file is part of Awali.
// Copyright 2016-2019 Sylvain Lombardy, Victor Marsault, Jacques Sakarovitch
//
// Awali is a free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#include <awali/dyn/core/abstract-ratexp.hh>

namespace awali { namespace dyn {

  ratexp_t
  operator+ (dyn::ratexp_t e1, dyn::ratexp_t e2)
  {
    return e1->add(e2);
  }


  ratexp_t
  operator* (dyn::ratexp_t e1, dyn::ratexp_t e2)
  {
    return e1->mult(e2);
  }


  std::ostream&
  operator<< (std::ostream& o, ratexp_t e)
  {
    return e->print(o);
  }


}}//end of ns awali::dyn
