// This file is part of Awali.
// Copyright 2016-2019 Sylvain Lombardy, Victor Marsault, Jacques Sakarovitch
//
// Awali is a free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef DYN_FACTOR_HH
#define DYN_FACTOR_HH

#include <awali/dyn/core/automaton.hh>

#include <awali/dyn/loading/handler.hh>

#include <awali/dyn/modules/factor.hh>

namespace awali { namespace dyn {

  void prefix_here(automaton_t aut) {
    loading::call<void, &prefix_here>("prefix_here", "factor",aut);
  }

  automaton_t prefix(automaton_t aut) {
    return loading::call<automaton_t, &prefix>("prefix", "factor",aut);
  }

  void suffix_here(automaton_t aut) {
    loading::call<void, &suffix_here>("suffix_here", "factor",aut);
  }

  automaton_t suffix(automaton_t aut) {
    return loading::call<automaton_t, &suffix>("suffix", "factor",aut);
  }

  void factor_here(automaton_t aut) {
    loading::call<void, &factor_here>("factor_here", "factor",aut);
  }

  automaton_t factor(automaton_t aut) {
    return loading::call<automaton_t, &factor>("factor", "factor",aut);
  }

}}//end of ns awali::dyn

#endif
