// This file is part of Awali.
// Copyright 2016-2019 Sylvain Lombardy, Victor Marsault, Jacques Sakarovitch
//
// Awali is a free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef DYN_MODULES_MINIMIZE_CC
#define DYN_MODULES_MINIMIZE_CC

#include <vector>
#include <unordered_set>
#include <sstream>
#include <iomanip>
#include <stdexcept>

#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/loading/handler.hh>

#include <awali/dyn/modules/minimize.hh>
#include <awali/dyn/modules/derivation.hh>

namespace awali {
  namespace dyn {
    //Boolean automata only
    automaton_t minimal_automaton(automaton_t aut, param_t algo) {
      return loading::call2<automaton_t, param_t, &minimal_automaton>("minimal_automaton", "minimize", aut, algo);
    }

    automaton_t minimal_automaton(ratexp_t exp, param_t algo) {
      return minimal_automaton(derived_term(exp, false, true), algo);
    }
  }
}//end of ns awali::dyn

#endif
